freeslot(
    "sfx_KUDSHM"
)

addHook("PlayerThink", function(p)
    
    if p.mo and p.mo.valid and p.mo.skin ~= "juniosonic" then
        return
    end

    if not (p.mo and p.mo.valid and p.charability2 == CA2_SPINDASH) then
        return
    end

    local allowedStates = {
        [S_PLAY_ROLL] = true,        
        [S_PLAY_SWIM] = true,       
        [S_PLAY_WALK] = true,            
        [S_PLAY_RUN] = true              
    }
    
    if not allowedStates[p.mo.state] then
        return
    end
    
    if not (p.cmd.buttons & BT_CUSTOM3) then
        return
    end
    
    if p.uncurldelay and not (p.pflags & PF_SPINNING) then
        p.uncurldelay = 0
    end
    
    if p.pflags & PF_STARTDASH or p.mo.dropcharged then
        p.uncurldelay = 15
    elseif p.uncurldelay then
        p.uncurldelay = $-1
    elseif p.pflags & PF_SPINNING
        and not (p.pflags & PF_STARTDASH)
        and not (p.cmd.buttons & BT_SPIN)
        and not p.powers[pw_carry]
        and not (p.mo.subsector.sector.specialflags & SSF_FORCESPIN)
        and p.mo.ceilingz - p.mo.floorz >= P_GetPlayerHeight(p) then
        p.pflags = $&~ PF_SPINNING
        
        if p.mo.state == S_PLAY_ROLL then
            p.mo.state = S_PLAY_WALK
        end
        
        
        local boost = 5 
        local angle = p.mo.angle
        p.mo.momx = $ + FixedMul(boost, cos(angle))
        p.mo.momy = $ + FixedMul(boost, sin(angle))
    end
    S_StartSound(p.mo, sfx_kudshm)
end)

local lockcurl = function(mo, t)
    if t.player and t.z <= mo.z + mo.height then
        
        if t.player.mo and t.player.mo.valid and t.player.mo.skin ~= "juniosonic" then
            return
        end
        
        
        if t.player.cmd.buttons & BT_CUSTOM3 then
            t.player.uncurldelay = TICRATE
           
            local boost = 5 
            local angle = t.angle
            t.momx = $ + FixedMul(boost, cos(angle))
            t.momy = $ + FixedMul(boost, sin(angle))
        end
    end
end

addHook("MobjCollide", lockcurl, MT_YELLOWBOOSTER)
addHook("MobjCollide", lockcurl, MT_REDBOOSTER)