// JunioSonic config
// To prevent duplicate freeslots
local function SafeFreeslot(...)
	for _, item in ipairs({...})
		if rawget(_G, item) == nil
			freeslot(item)
		end
	end
end


SafeFreeslot("SPR_AIDU", "S_KICKDUST")

states[S_KICKDUST] = {
	sprite = SPR_AIDU,
	frame = FF_ANIMATE | FF_PAPERSPRITE,
	var1 = 5,
	var2 = 1,
	tics = 6
}