addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_ROBOHOOD)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 28
	and m.target
	and (m.eflags & MFE_ONGROUND)
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ARROW)
		S_StartSound(m, sfx_s3ka0)
		A_FaceTarget(m)
		m.shootwait = 0
	end
end, MT_ROBOHOOD)

addHook("MobjSpawn", function(m)
	m.mad = 0
	P_SpawnMobjFromMobj(m, 64, 0, 0, MT_SPIKEBALL)
	A_FindTracer(m, MT_SPIKEBALL, 0)
	m.tracer.target = m
	m.tracer.state = S_SPIKEBALL1A
	P_SetOrigin(m.tracer, (m.x - 128), (m.y - 128), (m.z - 128))
	m.tracer = nil
end, MT_EGGGUARD)

addHook("MobjThinker", function(m)
	if m.state == S_EGGGUARD_MAD1
		m.mad = 1
	end
	if m.mad == 1
		m.destscale = (FRACUNIT/2)*3
	end
	if m.mad == 1
	and m.state == S_EGGGUARD_STND
		m.destscale = FRACUNIT
		m.mad = 0
	end
end, MT_EGGGUARD)

addHook("MobjDeath", function(m)
		S_StartSound(m, sfx_s3k4e)
end, MT_EGGGUARD)

addHook("MobjSpawn", function(m)
	P_SpawnMobjFromMobj(m, 64, 0, 0, MT_SPIKEBALL)
	A_FindTracer(m, MT_SPIKEBALL, 0)
	m.tracer.target = m
	m.tracer.angle = ANGLE_180
	m.tracer.state = S_SPIKEBALL1A
	P_SetOrigin(m.tracer, (m.x - 128), (m.y - 128), (m.z - 128))
	m.tracer = nil
	P_SpawnMobjFromMobj(m, -64, 0, 0, MT_SPIKEBALL)
	A_FindTarget(m, MT_SPIKEBALL, 0)
	m.target.target = m
	m.target.state = S_SPIKEBALL1A
	m.target = nil
end, MT_VULTURE)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_JETTGUNNER)
addHook("MobjThinker", function(m)
	if (m.flags2 & MF2_AMBUSH)
		m.shootwait = m.shootwait+1
		if m.shootwait >= 70
		and m.target
		and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 700*FRACUNIT
			P_SpawnMissile(m, m.target, MT_JETTBULLET)
			S_StartSound(m, sfx_s3k4d)
			m.shootwait = 0
		end
	end
end, MT_JETTGUNNER)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_JETTBOMBER)
addHook("MobjThinker", function(m)
	if (m.flags2 & MF2_AMBUSH)
		m.shootwait = m.shootwait+1
		if m.shootwait >= 35
			A_TrapShot(m, MT_MINE, 270)
			S_StartSound(m, sfx_s3k51)
			m.shootwait = 0
		end
	end
end, MT_JETTBOMBER)
addHook("ShouldDamage", function(t, i, s, d, dt)
	if i.type == MT_DRAGONMINE
		return false
	end
end, MT_JETTBOMBER)

addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_CRAWLACOMMANDER)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 105
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait = 0
	end
end, MT_CRAWLACOMMANDER)

addHook("MobjSpawn", function(m)
	m.shootwait = 210
	m.shootwait2 = 0
end, MT_UNIDUS)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 245
	and m.target
		m.shootwait2 = 5
		m.shootwait = 0
	end
	if m.shootwait2 > 0
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 600*FRACUNIT
	and P_RandomRange(1, 20) == 1
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait2 = m.shootwait2-1
	end
end, MT_UNIDUS)